data_module = {};

function load_data_module()
	if watchtower_modules.data_module == nil then
		watchtower_modules.data_module = {}; 
	end
	
	watchtower_modules.data_module.containers = {
		
		{name = "Threat",
			x = 290, 
			y = 260, 
			self_anchor = "TOPLEFT",
			relativeto = "inner_frame",
			parent_anchor = "TOPLEFT",
			x_offset = 17,
			y_offset = -20,
			title = "Threat Counters"
		},
		
		{name = "Duration", 
			x= 155,
			y= 260,
			self_anchor = "LEFT",
			relativeto = "Threat",
			parent_anchor = "RIGHT",
			x_offset = 10,
			y_offset = 0,
			title = "Specials"
		},
	
		{name = "Experience", 
			x= 128,
			y= 260,
			self_anchor = "LEFT",
			relativeto = "Duration",
			parent_anchor = "RIGHT",
			x_offset = 10,
			y_offset = 0,
			title = "XP Bonus"
		},
		
		{name = "Group", 
			x= 425,
			y= 260,
			self_anchor = "LEFT",
			relativeto = "Experience",
			parent_anchor = "RIGHT",
			x_offset = 10,
			y_offset = 0,
			title = "Group Bonus"
		},
		
		{name = "Slayer", 
			x= 290,
			y= 260,
			self_anchor = "TOPLEFT",
			relativeto = "Threat",
			parent_anchor = "BOTTOMLEFT",
			x_offset = 30,
			y_offset = -20,
			title = "Enemy Race Bonus"
		},
	
		{name = "Terrain", 
			x= 263,
			y= 260,
			self_anchor = "LEFT",
			relativeto = "Slayer",
			parent_anchor = "RIGHT",
			x_offset = 10,
			y_offset = 0,
			title = "Terrain Bonus"
		},
		
		{name = "Profession", 
			x= 398,
			y= 260,
			self_anchor = "LEFT",
			relativeto = "Terrain",
			parent_anchor = "RIGHT",
			x_offset = 10,
			y_offset = 0,
			title = "Professions"
		},
		
	};

	
	-- next data item -- 
	
	watchtower_modules.data_module.traits ={
	
		{name = "Wild Aggression",
			icon = "Interface\\ICONS\\Spell_Nature_Reincarnation.blp",
			self_anchor = "BOTTOMLEFT",
			relativeto = "Threat",
			parent_anchor = "BOTTOMLEFT",
			x_offset = 25,
			y_offset = 18,
			active = {},
			inactive = {},
			prime = true
		},
		
		{name = "Massive Strike",
			icon = "Interface\\ICONS\\Ability_Warrior_SavageBlow.blp",
			self_anchor = "LEFT",
			relativeto = "Wild Aggression",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Group Damage",
			icon = "Interface\\ICONS\\Spell_Fire_SelfDestruct.blp",
			self_anchor = "LEFT",
			relativeto = "Massive Strike",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Magic Debuff",
			icon = "Interface\\ICONS\\Spell_Shadow_ShadowWordPain.blp",
			self_anchor = "LEFT",
			relativeto = "Group Damage",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Danger Zones",
			icon = "Interface\\ICONS\\spell_Shaman_Earthquake.blp",
			self_anchor = "LEFT",
			relativeto = "Magic Debuff",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Minion Swarms",
			icon = "Interface\\ICONS\\Spell_DeathKnight_ArmyOfTheDead.blp",
			self_anchor = "LEFT",
			relativeto = "Danger Zones",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
		
		},
		
		{name = "Powerful Spell",
			icon = "Interface\\ICONS\\Spell_Shadow_ShadowBolt.blp",
			self_anchor = "LEFT",
			relativeto = "Minion Swarms",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Deadly Minions",
			icon = "Interface\\ICONS\\Achievement_Boss_TwinOrcBrutes.blp",
			self_anchor = "LEFT",
			relativeto = "Powerful Spell",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Timed Battle",
			icon = "Interface\\ICONS\\SPELL_HOLY_BORROWEDTIME.BLP",
			self_anchor = "LEFT",
			relativeto = "Deadly Minions",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Epic Mount",
			icon = "Interface\\ICONS\\MountJournalPortrait.blp",
			self_anchor = "BOTTOMLEFT",
			relativeto = "Duration",
			parent_anchor = "BOTTOMLEFT",
			x_offset = 25,
			y_offset = 18,
			active = {},
			inactive = {},
			prime = true
		},
		
		{name = "High Stamina",
			icon = "Interface\\ICONS\\Spell_Holy_WordFortitude.blp",
			self_anchor = "LEFT",
			relativeto = "Epic Mount",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
		
		},
		
		{name = "Burst of Power",
			icon = "Interface\\ICONS\\Spell_Nature_ShamanRage.blp",
			self_anchor = "LEFT",
			relativeto = "High Stamina",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Scavenger",
			icon = "Interface\\ICONS\\ACHIEVEMENT_GUILDPERK_BOUNTIFULBAGS.BLP",
			self_anchor = "LEFT",
			relativeto = "Burst of Power",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Extra Training",
			icon = "Interface\\ICONS\\Garrison_Building_SparringArena.blp",
			self_anchor = "BOTTOMLEFT",
			relativeto = "Experience",
			parent_anchor = "BOTTOMLEFT",
			x_offset = 25,
			y_offset = 18,
			active = {},
			inactive = {},
			prime = true
		},
		
		{name = "Hearthstone Pro",
			icon = "Interface\\ICONS\\Item_Hearthstone_Card.blp",
			self_anchor = "LEFT",
			relativeto = "Extra Training",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Fast Learner",
			icon = "Interface\\ICONS\\Ability_Mage_StudentOfTheMind.blp",
			self_anchor = "LEFT",
			relativeto = "Hearthstone Pro",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Gnome Lover",
			icon = "Interface\\ICONS\\Achievement_Character_Gnome_Male.blp",
			self_anchor = "BOTTOMLEFT",
			relativeto = "Group",
			parent_anchor = "BOTTOMLEFT",
			x_offset = 25,
			y_offset = 18,
			active = {},
			inactive = {},
			prime = true
		},
		
		{name = "Humanist",
			icon = "Interface\\ICONS\\Achievement_Character_Human_Female.blp",
			self_anchor = "LEFT",
			relativeto = "Gnome Lover",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Dwarvenborn",
			icon = "Interface\\ICONS\\Achievement_Character_Dwarf_Female.blp",
			self_anchor = "LEFT",
			relativeto = "Humanist",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Child of the Moon",
			icon = "Interface\\ICONS\\Achievement_Character_Nightelf_Male.blp",
			self_anchor = "LEFT",
			relativeto = "Dwarvenborn",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Ally of Argus",
			icon = "Interface\\ICONS\\Achievement_Character_Draenei_Male.blp",
			self_anchor = "LEFT",
			relativeto = "Child of the Moon",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Canine Companion",
			icon = "Interface\\ICONS\\Ability_Worgen_DarkFlight.blp",
			self_anchor = "LEFT",
			relativeto = "Ally of Argus",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Brew Aficionado",
			icon = "Interface\\ICONS\\Achievement_Character_Pandaren_Female.blp",
			self_anchor = "LEFT",
			relativeto = "Canine Companion",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Child of Draenor",
			icon = "Interface\\ICONS\\Achievement_Character_Orc_Female.blp",
			self_anchor = "LEFT",
			relativeto = "Brew Aficionado",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Death Fascination",
			icon = "Interface\\ICONS\\Achievement_Character_Undead_Female.blp",
			self_anchor = "LEFT",
			relativeto = "Child of Draenor",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Totemist",
			icon = "Interface\\ICONS\\Achievement_Character_Tauren_Male.blp",
			self_anchor = "LEFT",
			relativeto = "Death Fascination",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Voodoo Zealot",
			icon = "Interface\\ICONS\\Achievement_Character_Troll_Male.blp",
			self_anchor = "LEFT",
			relativeto = "Totemist",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Elvenkind",
			icon = "Interface\\ICONS\\Achievement_Character_Bloodelf_Male.blp",
			self_anchor = "LEFT",
			relativeto = "Voodoo Zealot",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Economist",
			icon = "Interface\\ICONS\\achievement_FemaleGoblinhead.blp",
			self_anchor = "LEFT",
			relativeto = "Elvenkind",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
		
		},
		
		{name = "Lone Wolf",
			icon = "Interface\\ICONS\\Ability_Shaman_FreedomWolf.blp",
			self_anchor = "LEFT",
			relativeto = "Economist",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Orcslayer",
			icon = "Interface\\ICONS\\Achievement_Boss_General_Nazgrim.blp",
			self_anchor = "BOTTOMLEFT",
			relativeto = "Slayer",
			parent_anchor = "BOTTOMLEFT",
			x_offset = 25,
			y_offset = 18,
			active = {},
			inactive = {},
			prime = true
		},
		
		{name = "Demonslayer",
			icon = "Interface\\ICONS\\Achievement_Boss_PrinceMalchezaar_02.blp",
			self_anchor = "LEFT",
			relativeto = "Orcslayer",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Beastslayer",
			icon = "Interface\\ICONS\\Achievement_Boss_kingdred.blp",
			self_anchor = "LEFT",
			relativeto = "Demonslayer",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Ogreslayer",
			icon = "Interface\\ICONS\\Achievement_Reputation_Ogre.blp",
			self_anchor = "LEFT",
			relativeto = "Beastslayer",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Primalslayer",
			icon = "Interface\\ICONS\\Achievement_Boss_YoggSaron_01.blp",
			self_anchor = "LEFT",
			relativeto = "Ogreslayer",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Gronnslayer",
			icon = "Interface\\ICONS\\Achievement_Boss_GruulTheDragonkiller.blp",
			self_anchor = "LEFT",
			relativeto = "Primalslayer",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Furyslayer",
			icon = "Interface\\ICONS\\Achievement_Boss_Ragnaros.blp",
			self_anchor = "LEFT",
			relativeto = "Gronnslayer",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Voidslayer",
			icon = "Interface\\ICONS\\Achievement_Boss_Zuramat.blp",
			self_anchor = "LEFT",
			relativeto = "Furyslayer",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Talonslayer",
			icon = "Interface\\ICONS\\INV_RavenLordPet.blp",
			self_anchor = "LEFT",
			relativeto = "Voidslayer",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Mountaineer",
			icon = "Interface\\ICONS\\Achievement_Zone_ThousandNeedles_01.blp",
			self_anchor = "BOTTOMLEFT",
			relativeto = "Terrain",
			parent_anchor = "BOTTOMLEFT",
			x_offset = 25,
			y_offset = 18,
			active = {},
			inactive = {},
			prime = true
		},

		{name = "Cold-blooded",
			icon = "Interface\\ICONS\\Achievement_Zone_StormPeaks_02.blp",
			self_anchor = "LEFT",
			relativeto = "Mountaineer",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Wastelander",
			icon = "Interface\\ICONS\\Achievement_Zone_Tanaris_01.blp",
			self_anchor = "LEFT",
			relativeto = "Cold-blooded",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Naturalist",
			icon = "Interface\\ICONS\\Achievement_Zone_Silverpine_01.blp",
			self_anchor = "LEFT",
			relativeto = "Wastelander",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Cave Dweller",
			icon = "Interface\\ICONS\\Achievement_Dungeon_Deepholm.blp",
			self_anchor = "LEFT",
			relativeto = "Naturalist",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Guerilla Fighter",
			icon = "Interface\\ICONS\\Achievement_Zone_UnGoroCrater_01.blp",
			self_anchor = "LEFT",
			relativeto = "Cave Dweller",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Marshwalker",
			icon = "Interface\\ICONS\\Achievement_Zone_Sholazar_03.blp",
			self_anchor = "LEFT",
			relativeto = "Guerilla Fighter",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Plainsrunner",
			icon = "Interface\\ICONS\\Achievement_Zone_ArathiHighlands_01.blp",
			self_anchor = "LEFT",
			relativeto = "Marshwalker",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Mining",
			icon = "Interface\\ICONS\\Trade_Mining.blp",
			self_anchor = "BOTTOMLEFT",
			relativeto = "Profession",
			parent_anchor = "BOTTOMLEFT",
			x_offset = 25,
			y_offset = 18,
			active = {},
			inactive = {},
			prime = true
		},
		
		{name = "Herbalism",
			icon = "Interface\\ICONS\\Trade_Herbalism.blp",
			self_anchor = "LEFT",
			relativeto = "Mining",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Alchemy",
			icon = "Interface\\ICONS\\Trade_Alchemy.blp",
			self_anchor = "LEFT",
			relativeto = "Herbalism",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Blacksmithing",
			icon = "Interface\\ICONS\\Trade_Blacksmithing.blp",
			self_anchor = "LEFT",
			relativeto = "Alchemy",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Enchanting",
			icon = "Interface\\ICONS\\Trade_Engraving.blp",
			self_anchor = "LEFT",
			relativeto = "Blacksmithing",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Engineering",
			icon = "Interface\\ICONS\\Trade_Engineering.blp",
			self_anchor = "LEFT",
			relativeto = "Enchanting",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
		
		},
		
		{name = "Inscription",
			icon = "Interface\\ICONS\\INV_Inscription_Tradeskill01.blp",
			self_anchor = "LEFT",
			relativeto = "Engineering",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Jewelcrafting",
			icon = "Interface\\ICONS\\INV_Misc_Gem_01.blp",
			self_anchor = "LEFT",
			relativeto = "Inscription",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Leatherworking",
			icon = "Interface\\ICONS\\Trade_LeatherWorking.blp",
			self_anchor = "LEFT",
			relativeto = "Jewelcrafting",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Tailoring",
			icon = "Interface\\ICONS\\Trade_Tailoring.blp",
			self_anchor = "LEFT",
			relativeto = "Leatherworking",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Skinning",
			icon = "Interface\\ICONS\\INV_Misc_Pelt_Wolf_01.blp",
			self_anchor = "LEFT",
			relativeto = "Tailoring",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Angler",
			icon = "Interface\\ICONS\\Achievement_Profession_Fishing_NorthrendAngler.blp",
			self_anchor = "LEFT",
			relativeto = "Skinning",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
		{name = "Bodyguard",
			icon = "Interface\\ICONS\\Ability_HanzandFranz_ChestBump.blp",
			self_anchor = "LEFT",
			relativeto = "Angler",
			parent_anchor = "RIGHT",
			x_offset = 3,
			y_offset = 0,
			active = {},
			inactive = {},
			
		},
		
	
	};
	
end

function populate_followers()

	local traitList = watchtower_modules.data_module.traits;
	
	for j = 1, #traitList do
		traitList[j].active = nil;
		traitList[j].inactive = nil;
		traitList[j].active = {};
		traitList[j].inactive = {};
	end
	
	
	
	local allFollowers = C_Garrison.GetFollowers();
	local myFollowers = {};
	for i = 1, #allFollowers do
		if allFollowers[i].isCollected then
			table.insert(myFollowers, allFollowers[i]);
		end
	end
			
	for key, trait in pairs(traitList) do
		for follower = 1, #myFollowers do
			local status = myFollowers[follower].status;
			follower_abilities = C_Garrison.GetFollowerAbilities(myFollowers[follower].followerID);
			for abilities = 1, #follower_abilities do
				ability = follower_abilities[abilities];
				if ability.isTrait then
					if ability.name == trait.name then
						if status == "Inactive" then
							trait.inactive[myFollowers[follower].name] = myFollowers[follower];
						else
							trait.active[myFollowers[follower].name] = myFollowers[follower];
						end
					end
				else
					for key, value in pairs(ability.counters) do
						if value.name == trait.name then
							if status == "Inactive" then
								trait.inactive[myFollowers[follower].name] = myFollowers[follower];
							else
								trait.active[myFollowers[follower].name] = myFollowers[follower];
							end
						end
					end
				end
			end
		end
	end
		
end --- end populate_followers
data_module.load_data_module = load_data_module;
data_module.populate_followers = populate_followers;