graph_module = {};

function load_graph_module()
	if watchtower_modules.graph_module == nil then
		watchtower_modules.graph_module = {};
	end
	
	frame_table = {};
	
	
	local event_frame = CreateFrame("Frame", "event_frame", UIParent);
	event_frame:RegisterEvent("GARRISON_MISSION_NPC_OPENED");
	event_frame:RegisterEvent("GARRISON_MISSION_NPC_CLOSED");
	event_frame:SetScript("OnEvent", function(self, event)
	
		if event == "GARRISON_MISSION_NPC_OPENED" then
			if not frame_table.tab then
				create_graph_tab();
				create_outer_frame();
				create_inner_frame();
				create_data_boxs();
				create_trait_buttons();
				
			end
		end;
		
		if event == "GARRISON_MISSION_NPC_CLOSED" then
			PanelTemplates_DeselectTab(frame_table.tab); 
			frame_table.outer_frame:Hide();
		end;
		
	
	end);

	
	
	function create_graph_tab()
	
		frame_table.tab = CreateFrame("Button", "GarrisonMissionFrameTab5", GarrisonMissionFrame, "GarrisonMissionFrameTabTemplate");
		frame_table.tab:SetPoint("LEFT", GarrisonMissionFrameTab2, "RIGHT", -5, 0);
		PanelTemplates_DeselectTab(frame_table.tab);
		frame_table.tab:SetText("Watchtower");
		PanelTemplates_TabResize(frame_table.tab, 10);
		
		GarrisonMissionFrameTab1:HookScript("OnClick", function()
			PanelTemplates_DeselectTab(frame_table.tab);
				if frame_table.outer_frame then
					frame_table.outer_frame:Hide();
				end
		end)
		
		GarrisonMissionFrameTab2:HookScript("OnClick", function()
			PanelTemplates_DeselectTab(frame_table.tab);
				if frame_table.outer_frame then
					frame_table.outer_frame:Hide();
				end
		end)
		
		if GarrisonMissionFrameTab3 then
			GarrisonMissionFrameTab3:HookScript("OnClick", function()
				PanelTemplates_DeselectTab(frame_table.tab);
					if frame_table.outer_frame then
						frame_table.outer_frame:Hide();
					end
			end)
		
			GarrisonMissionFrameTab4:HookScript("OnClick", function()
				PanelTemplates_DeselectTab(frame_table.tab);
					if frame_table.outer_frame then
						frame_table.outer_frame:Hide();
					end
			end)
		end
		
		
		frame_table.tab:SetScript("OnClick", function()	
			PanelTemplates_DeselectTab(GarrisonMissionFrameTab1);
			PanelTemplates_DeselectTab(GarrisonMissionFrameTab2);
			if GarrisonMissionFrameTab3 then
				PanelTemplates_DeselectTab(GarrisonMissionFrameTab3);
				PanelTemplates_DeselectTab(GarrisonMissionFrameTab4);
			end
			PanelTemplates_SelectTab(frame_table.tab);
			
			-- put update call here -- 
			update_follower_data();
			
			frame_table.outer_frame:Show();
		end);
		
	end;
	
	function create_outer_frame()
	
		local x_size, y_size = GarrisonMissionFrame:GetSize();
		x_size = x_size * 1.2;
		frame_table.outer_frame = CreateFrame("Frame", "outer_frame", UIParent, "GarrisonUITemplate");
		frame_table.outer_frame:SetPoint("BOTTOM", GarrisonMissionFrame, "BOTTOM");
		frame_table.outer_frame:SetSize(x_size, y_size);
		frame_table.outer_frame:Hide();
		frame_table.outer_frame:SetFrameStrata("HIGH");
		frame_table.outer_frame:EnableMouse(true);
		frame_table.outer_frame.CloseButton:SetScript("OnClick", function()
			GarrisonMissionFrame:Hide();
			frame_table.outer_frame:Hide();
		end);
		frame_table.outer_frame:CreateFontString("Title","ARTWORK" ,"GameFontNormal");
		Title:SetText("Watchtower Version 0.2");
		Title:SetPoint("TOP", 0, -5);
		frame_table.outer_frame:CreateFontString("Footer", "ARTWORK", "GameFontNormalSmall");
		Footer:SetText("Lot20Syndicate");
		Footer:SetPoint("BOTTOMRIGHT", -50, 5);
		
	end
	
	function create_inner_frame()
	
		local x_size, y_size = GarrisonMissionFrame:GetSize();
		x_size = x_size * 1.2;
		frame_table.inner_frame = CreateFrame("Frame", "inner_frame", frame_table.outer_frame, "GarrisonMissionBaseFrameTemplate");
		frame_table.inner_frame:SetPoint("CENTER");
		frame_table.inner_frame:SetSize((x_size*0.92), (y_size * 0.88));
		
	end
	
	function create_data_boxs()
		
		local data = watchtower_modules.data_module.containers;
		local backdrop = {bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 32};
		for index = 1, #data do
			local frame = CreateFrame("Frame", data[index].name, frame_table.inner_frame );
			frame:SetBackdrop(backdrop);
			frame:SetSize(data[index].x, data[index].y);
			frame:SetPoint(data[index].self_anchor, data[index].relativeto, data[index].parent_anchor, data[index].x_offset, data[index].y_offset);
			local title = frame:CreateFontString(nil, "ARTWORK", "QuestFont_Large");
			title:SetText("|cffffff00" .. data[index].title .. "|r");
			title:SetPoint("TOP", 0, -2);
			
			for index2 = -9,9 do
				local line = frame:CreateTexture(nil);
				line:SetTexture(1.0, 1.0, 1.0, 0.1);
				line:SetSize((data[index].x - 50),1);
				line:SetPoint("CENTER", 0, (index2 * 9));
				local numleft = frame:CreateFontString(nil,"ARTWORK" ,"GameFontNormalSmall");
				local numright = frame:CreateFontString(nil,"ARTWORK" ,"GameFontNormalSmall");
				numleft:SetPoint("LEFT", line, "RIGHT", 5, 0);
				numright:SetPoint("RIGHT", line, "LEFT",-5, 0);
				if index2 < 0 then
					numleft:SetText(index2 * (-1));
					numright:SetText(index2 * (-1));
				else
					numleft:SetText(index2);
					numright:SetText(index2);
				end
			end
		end
		
	end
	
	
	function create_trait_buttons()
		local trait = watchtower_modules.data_module.traits;
		frame_table.buttons = {};
		
		for index = 1, #trait do
			
			frame_table.buttons[index] = CreateFrame("Button", trait[index].name, inner_frame);
			frame_table.buttons[index]:SetNormalTexture(trait[index].icon);
			frame_table.buttons[index]:SetSize(24,24);
			frame_table.buttons[index]:SetPoint(trait[index].self_anchor, trait[index].relativeto, trait[index].parent_anchor, trait[index].x_offset, trait[index].y_offset);
			
			frame_table.buttons[index].active = frame_table.buttons[index]:CreateTexture(trait[index].name .. "_active");
			frame_table.buttons[index].active:SetTexture(0.0,0.8,0.0,0.3);
			frame_table.buttons[index].active:SetSize(24,9);
			
			frame_table.buttons[index].inactive = frame_table.buttons[index]:CreateTexture(trait[index].name .. "_inactive");
			frame_table.buttons[index].inactive:SetTexture(0.8,0.0,0.0,0.3);
			frame_table.buttons[index].inactive:SetSize(16,9);
			
			if trait[index].prime then
				frame_table.buttons[index].active:SetPoint("BOTTOMLEFT", trait[index].relativeto, "LEFT", trait[index].x_offset, 1);
			else
				frame_table.buttons[index].active:SetPoint("BOTTOMLEFT", trait[index - 1].name .. "_active", "BOTTOMRIGHT", trait[index].x_offset, 0);
			end
			
			frame_table.buttons[index].inactive:SetPoint("TOP", trait[index].name .."_active" , "BOTTOM", 0, -1);
			
		end
	end
	
	-- next function -- 
	
	function update_follower_data()
		
		data_module.populate_followers();
		local traitList = watchtower_modules.data_module.traits;
		
		
		
		--redraw textures and update tooltips
		
		function the_count(arg)
			counter = 0;
			for key in pairs(arg) do
				counter = counter +1;
			end
			return counter;
		end
		
		
		for i = 1, #frame_table.buttons do
		
			local fontstring = frame_table.buttons[i]:CreateFontString(frame_table.buttons[1].name, "Overlay", "GameFontNormal");
			fontstring:SetPoint("RIGHT", "$parent", "RIGHT", 0, -20);
			fontstring:SetJustifyH("RIGHT");
			fontstring:SetText("(" .. the_count(traitList[i].active) + the_count(traitList[i].inactive) .. ")");
			
		end
		
		
		for i = 1, #frame_table.buttons do
			if the_count(traitList[i].active) == 0 then
				frame_table.buttons[i].active:SetTexture(0.0,0.8,0.0,0.0);
			else
				if the_count(traitList[i].active) > 9 then
					active_count = 9;
					
				else
					active_count = the_count(traitList[i].active);
				end
				frame_table.buttons[i].active:SetSize(24,(active_count * 9));
			end
		
			if the_count(traitList[i].inactive) == 0 then
				frame_table.buttons[i].inactive:SetTexture(0.0,0.8,0.0,0.0);
			else
				if the_count(traitList[i].inactive) > 9 then
					inactive_count = 9;
				else
					inactive_count = the_count(traitList[i].inactive);
				end
				frame_table.buttons[i].inactive:SetSize(16,(inactive_count * 9));
			end
		end
			
		
		-- here
		for i = 1, #frame_table.buttons do
			
			frame_table.buttons[i]:SetScript("OnEnter", function(self, motion)
				GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT");
				GameTooltip:SetText(traitList[i].name);
				new_active = {};
				new_inactive = {};
				
				for key,value in pairs(traitList[i].active) do
					table.insert(new_active, value);
				end
				table.sort(new_active, follower_sorting);
				
				for key,value in pairs(traitList[i].inactive) do
					table.insert(new_inactive, value);
				end
				table.sort(new_inactive, follower_sorting);
				
				tipsy(new_active);
				if #new_inactive ~= 0 then
					GameTooltip:AddDoubleLine(" ", " ");
				end
				tipsy(new_inactive);
				
				GameTooltip:Show();
			end);
			
			frame_table.buttons[i]:SetScript("OnLeave", function(self, motion)
				GameTooltip:Hide();
			end);
			
			
		end -- end of for loop

	end -- end of update function
	
	function tipsy(tbl)
	
		local status = "|cffffffff[|r" .. "|cff1eff00Active|r" .. "|cffffffff]|r";
		
		
		for key, value in ipairs(tbl) do
		
			if value.status == "Inactive" then
				status = "|cffffffff[|r" .. "|cffff0000Inactive|r" .. "|cffffffff]|r";
			end
			
			if value.quality == 4 then
				if value.level < 100 then
					GameTooltip:AddDoubleLine("|cffa335ee[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
				else
					GameTooltip:AddDoubleLine("|cffa335ee[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
				end
			elseif value.quality == 3 then
				if value.level < 100 then
					GameTooltip:AddDoubleLine("|cff0070dd[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
				else
					GameTooltip:AddDoubleLine("|cff0070dd[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
				end
			elseif value.quality == 2 then
				if value.level < 100 then
					GameTooltip:AddDoubleLine("|cff1eff00[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
				else
					GameTooltip:AddDoubleLine("|cff1eff00[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
				end
			end
		end
	end -- end of tipsy

	function follower_sorting(a, b)

		if a.iLevel > b.iLevel then
			return true		
		elseif a.iLevel == b.iLevel then
			if a.level > b.level then
				return true
			elseif a.level == b.level then
				if a.quality > b.quality then
					return true
				elseif a.quality == b.quality then
					if a.name < b.name then
						return true
					else 
						return false
					end
				end
			end
			return false
		end
	end -- end of follower_sorting
	
	
	
		
end;
graph_module.load_graph_module = load_graph_module;